class OxUser < AbstractResource #< ActiveRecord::Base
  self.table_name = 'users'
  establish_connection ((Rails.env=="development") ? :dev_oxen_tables : :oxen_tables )

  include Roleable

  has_paper_trail

  belongs_to :account, foreign_key: 'account_id'
  has_many :invitations, :class_name => self.to_s, :as => :invited_by

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable, :database_authenticatable
  # devise :cas_authenticatable
  devise :invitable, :registerable, :confirmable, :database_authenticatable,
         :recoverable, :rememberable, :trackable, :validatable, :zxcvbnable #, :cas_authenticatable

  validates :name, presence: true

  before_create { generate_token(:auth_token) }

  def generate_token(column)
    begin
      self[column] = SecureRandom.urlsafe_base64
    end while User.exists?(column => self[column])
  end

  # #after_create :create_account
  #
  # # belongs_to :account
  #
  # # validates :name, presence: true
  #
  #
  # def create_account(account_name=nil)
  #   account_name ||= self.name
  #   if self.account.nil?
  #     self.account= Account.create name: account_name
  #   end
  # end
  #
  # def good_roles
  #   User.roles.keys.map {|r| ([r.titleize,r] if User.roles[role] >= User.roles[r]) }
  # end
  #

  # This is an internal method called every time Devise needs
  # to send a notification/mail. This can be overridden if you
  # need to customize the e-mail delivery logic. For instance,
  # if you are using a queue to deliver e-mails (delayed job,
  # sidekiq, resque, etc), you must add the delivery to the queue
  # just after the transaction was committed. To achieve this,
  # you can override send_devise_notification to store the
  # deliveries until the after_commit callback is triggered:
  #
  #     class User
  #       devise :database_authenticatable, :confirmable
  #
  #       after_commit :send_pending_notifications
  #
  #       protected
  #
  #       def send_devise_notification(notification, *args)
  #         # If the record is new or changed then delay the
  #         # delivery until the after_commit callback otherwise
  #         # send now because after_commit will not be called.
  #         if new_record? || changed?
  #           pending_notifications << [notification, args]
  #         else
  #           devise_mailer.send(notification, self, *args).deliver
  #         end
  #       end
  #
  #       def send_pending_notifications
  #         pending_notifications.each do |notification, args|
  #           devise_mailer.send(notification, self, *args).deliver
  #         end
  #
  #         # Empty the pending notifications array because the
  #         # after_commit hook can be called multiple times which
  #         # could cause multiple emails to be sent.
  #         pending_notifications.clear
  #       end
  #
  #       def pending_notifications
  #         @pending_notifications ||= []
  #       end
  #     end
  #
  # def send_devise_notification(notification, *args)
  #  devise_mailer.send(notification, self, *args).deliver
  # end




end
