module Oxen
  class UserPolicy < AbstractResourcePolicy

    class Scope < Scope
      def resolve
        if current_user.nil?
          super
        elsif current_user.admin?
          scope.all
        else
          scope.where(account_id: current_user.account.id)
        end
      end
    end


    def index?
      current_user.admin? || current_user.account_admin?
    end

    def show?
      current_user.admin? or current_user.account_admin? or current_user == model
    end

    def update?
      current_user.admin? || current_user.account_admin?
    end

    def create?
      current_user.admin? || current_user.account_admin?
    end

    def destroy?
      return false if @current_user == model
      current_user.admin? || current_user.account_admin?
    end

    def confirm?
      current_user.admin? || current_user.account_admin?
    end

    def invite?
      current_user.admin? || current_user.account_admin?
    end

  end

end
