Rails.application.routes.draw do

  devise_for :users, :controllers => { :invitations => 'users/invitations' }

  concern :printing do
    member do
      get 'print'
    end
    collection do
      get 'print'
    end
  end

  # prefer and defer elements (setting preferred true|false)
  concern :preferring do
    member do
      get 'prefer'
      get 'defer'
    end
  end

  # attach and detach the route in question to its 'parent'
  concern :attaching do
    member do
      get 'attach'
      get 'detach'
    end
  end

  # activate and passify the route in question
  concern :activating do
    member do
      get 'activate'
      get 'deactivate'
    end
  end


  scope '/admin' do
    resources :users, concerns: [:activating, :attaching, :printing] do
      member do
        get 'confirm'
      end
      resources :printers, concerns: [:preferring, :activating, :attaching, :printing]
    end
  end



end
